#!/usr/local/bin/ruby
#  encoding: utf-8
#  d_params.rb
#
#  Created by midori on 2006-09-24.
#  Copyright (c) 2006. All rights reserved.
#  You can distribute/modify this program under the terms of the Ruby License.
#  Last change: 2006-10-23.
#______________________________________________________________ BaseClass
class GetParams
  require "cgi"
  require "nkf"
  def initialize
    # & # ; not must escape!! for reason is 'Ruby/XSLT' 's Parser.
    @cgi = CGI.new
    @escape_list = {
      /\&/=>"&amp;",
      /\!/=>"&#33;", /\"/=>"&#34;", /\$/=>"&#36;", /\%/=>"&#37;", /\'/=>"&#39;",
      /\(/=>"&#40;", /\)/=>"&#41;", /\*/=>"&#42;", /\+/=>"&#43;", /\,/=>"&#44;", /\-/=>"&#45;",
      /\./=>"&#46;", /\//=>"&#47;", /\:/=>"&#58;", 
      /\</=>"&#60;", /\=/=>"&#61;", /\>/=>"&#62;", /\?/=>"&#63;", /\@/=>"&#64;",
      /\[/=>"&#91;",  /\\/=>"&#92;", /\]/ =>"&#93;", /\^/ =>"&#94;", /\_/ =>"&#95;", /\`/ =>"&#96;", 
      /\{/ =>"&#123;", /\|/ =>"&#124;", /\}/ =>"&#125;", /\~/ =>"&#126;",
      /\°/ =>"&#176;", /sun/ =>"&#9728;",
      /こまった！/=> "&#8242;&#8275;&#8245;", /あっ！/=> "&#40; &#39;&#48;&#39;&#41;",
      /にっこり！/=>"&#40; &#39;&#8255;&#39;&#41;", /きく！/=>"&#40; &#728;&#728;&#41; &#9836;", /commandkey/=>"&#8984;",
      /neko/=> "&#61;&#40;&#9021;&#8248;&#9021;&#41;&#61;", /onpu/=> "&#9836;",
      /niko/=>"&#40; &#39;&#8980;&#39;&#41;", /enmark/=> "&#165;"
      }
  end
  def get_all_params
    ex = Hash.new
    apache_agent = ENV["HTTP_USER_AGENT"]
    apache_addr = ENV["REMOTE_ADDR"] 

    p_data = @cgi.params
    p_data.each{|key,value|
      ex['error'] = key if value.to_s.empty?
      str = value.to_s
      u_str = NKF.nkf('-w -Lu', str ) #Utf8
        @escape_list.each{|keys, values| u_str.gsub!(keys, "#{values}")}        
        ex[key] = u_str
    }
     ex['env_ip'] = apache_addr
     ex['env_agent'] = apache_agent
     return ex
  end
end